unit uDropTargetModule;

interface

uses
    Windows,
    Messages,
    SysUtils,
    Classes,
    Forms,
    SxComObj,
    SxDataModule, SxCustShlObj, SxDropHandler, Dialogs, SxTools, SxConst,
    Controls;

type
  TSxDropTargetModule = class(TSxModule)
    sxFileDropTarget: TsxFileDropTarget;
    procedure sxFileDropTargetDragEnter(Sender: TsxFileDropTarget;
      const DropInfo: TsxFileDropInfo);
    procedure sxFileDropTargetDrop(Sender: TsxFileDropTarget;
      const DropInfo: TsxFileDropInfo);
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  end;

implementation

uses ComServ;

{$R *.DFM}


procedure TSxDropTargetModule.sxFileDropTargetDragEnter(
  Sender: TsxFileDropTarget; const DropInfo: TsxFileDropInfo);
var
  i:Integer;
begin
  DropInfo.DropEffect:=[sdeCopy];
  for i:=0 to DropInfo.FileList.Count-1 do
      if GetFileClass(DropInfo.FileList[i])<>'txtfile' then
      begin
        DropInfo.DropEffect:=[];
        Break;
      end;
end;

procedure TSxDropTargetModule.sxFileDropTargetDrop(
  Sender: TsxFileDropTarget; const DropInfo: TsxFileDropInfo);
var
  source:TStrings;
  dest:TStrings;
  i:Integer;
begin
  if MessageDlg('Are you sure to merge selected files to file "'+
     ExtractFileName(sxFileDropTarget.FileName)+'"?',
     mtConfirmation, [mbYes,mbNo], 0)=mrYes then
  begin
    source:=TStringList.Create;
    try
      dest:=TStringList.Create;
      try
        dest.LoadFromFile(sxFileDropTarget.FileName);
        for i:=0 to DropInfo.FileList.Count-1 do
        begin
          source.LoadFromFile(DropInfo.FileList[i]);
          dest.AddStrings(source);
        end;
        dest.SaveToFile(sxFileDropTarget.FileName);
      finally
        FreeAndNil(dest);
      end;
    finally
      FreeAndNil(source);
    end;
  end;
end;

initialization
    RegisterSxDataModule(ComServer,TSxDropTargetModule);
end.












